﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Vintagestory.API.Client;
using Vintagestory.Client.NoObf;
using Vintagestory.Client;
using Vintagestory.API.Config;
using Vintagestory.API.Common;
using Vintagestory.API.Server;
using Vintagestory.API.Common.Entities;
using Vintagestory.API.MathTools;
using Vintagestory.API.Util;
using Vintagestory.GameContent;
using Vintagestory.API.Datastructures;
using ProtoBuf;

namespace nearsight
{
    class SettingsSync : ModSystem
    {
        ICoreAPI api;

        public override double ExecuteOrder()
        {
            return 0.3d;
        }

        public override void Start(ICoreAPI api)
        {
            base.Start(api);
            this.api = api;
            api.Network.RegisterChannel("syncnearsightsettings").RegisterMessageType<SyncSettingsPacket>();
        }

        public override void StartClientSide(ICoreClientAPI api)
        {
            api.Network.GetChannel("syncnearsightsettings").SetMessageHandler<SyncSettingsPacket>(onSyncSettingsPacket);
            base.StartClientSide(api);
        }

        public override void StartServerSide(ICoreServerAPI api)
        {
            base.StartServerSide(api);

            api.Event.PlayerJoin += OnPlayerJoin;
        }

        public void OnPlayerJoin(IServerPlayer byPlayer)
        {
            SyncSettings(byPlayer);
        }

        public void SyncSettings(IServerPlayer byPlayer)
        {
            SyncSettingsPacket packet = new SyncSettingsPacket();

            packet.MinBlurDistance = byPlayer.GetModData<float>("nearsightSettings.Distance", 0f);
            packet.BlurRadius = byPlayer.GetModData<float>("nearsightSettings.Strength", 0f);
            packet.BlurEnabled = byPlayer.GetModData<bool>("nearsightSettings.Enabled", false);

            (api as ICoreServerAPI).Network.GetChannel("syncnearsightsettings").SendPacket<SyncSettingsPacket>(packet, new IServerPlayer[] { byPlayer });
        }

        public void onSyncSettingsPacket(SyncSettingsPacket packet)
        {
            NearsightMod.nearsightSettings.MinBlurDistance = packet.MinBlurDistance;
            NearsightMod.nearsightSettings.BlurRadius = packet.BlurRadius;
            NearsightMod.nearsightSettings.BlurEnabled = packet.BlurEnabled;
            //player.SendMessage(GlobalConstants.GeneralChatGroup, "Message photo serveur", EnumChatType.AllGroups);
        }

    }
    [ProtoContract]
    public class SyncSettingsPacket
    {
        [ProtoMember(1)]
        public float MinBlurDistance;
        [ProtoMember(2)]
        public float BlurRadius;
        [ProtoMember(3)]
        public bool BlurEnabled;
    }
}
