﻿#version 330 core

in vec2 uv;

out vec4 outColor;

uniform float time;
uniform float xs;
uniform float ys; // texture resolution
uniform float r; // radius

uniform sampler2D depthTexture;
uniform sampler2D colorTexture;

float map(float value, float min1, float max1, float min2, float max2) {
  return min2 + (value - min1) * (max2 - min2) / (max1 - min1);
}

vec4 blur(sampler2D image, vec2 uv, vec2 resolution, vec2 direction) {
  vec4 color = vec4(0.0);
  vec2 off1 = vec2(1.3333333333333333) * direction;
  color += texture2D(image, uv) * 0.29411764705882354;
  color += texture2D(image, uv + (off1 / resolution)) * 0.35294117647058826;
  color += texture2D(image, uv - (off1 / resolution)) * 0.35294117647058826;
  return color; 
}

/*vec4 blur(sampler2D txr, vec2 pos)
{
    pos = vec2(pos[0] * 2 - 1, pos[1] * 2 - 1);

    float x,y,xx,yy,rr=r*r,dx,dy,w,w0;
    w0=0.3780/pow(r,1.975);
    vec2 p;
    vec4 col=vec4(0.0,0.0,0.0,0.0);
    for (dx=1.0/xs,x=-r,p.x=0.5+(pos.x*0.5)+(x*dx);x<=r;x++,p.x+=dx){ xx=x*x;
        for (dy=1.0/ys,y=-r,p.y=0.5+(pos.y*0.5)+(y*dy);y<=r;y++,p.y+=dy){ yy=y*y;
        if (xx+yy<=rr)
        {
        w=w0*exp((-xx-yy)/(2.0*rr));
        col+=texture2D(txr,p)*w;
        }}}
    return col;
}*/

void main () {
    vec4 depth = texture2D(depthTexture, uv);
    vec4 color = texture2D(colorTexture, uv);

    float col = depth[0];

    //outColor = depth[0] > 0.98 ? blur(colorTexture, uv) : color;

    float lerpValue = clamp(map(depth[0], 0.95, 1, 0, 1), 0, 1);

    //outColor = mix(color, blur(colorTexture, uv), lerpValue);
    outColor = mix(color, blur(colorTexture, uv, vec2(xs, ys), vec2(0, 1)), lerpValue);

    //outColor = depth[0] > 0.98 ? vec4(0, 0, 0, 1) : vec4(1, 1, 1, 1);
}